/* Copyright 2004 Dan Risacher (not that I'm proud of it, mind you) */
/* May be used for any purpose so long as copyright remains in the source code */
/* Heavily hacked by jmdault@revolutionlinux.com */

#include <stdio.h>
#include <fcntl.h>
#include <linux/cdrom.h>
#include <limits.h>

int
main(int argc, char **argv)
{
  int fd, cdtype, arg=0;
  int res1, res2;

  fd = open("/dev/cdrom", O_RDONLY|O_NONBLOCK);

  if (fd < 0) {
    fprintf(stderr,"%s cannot be opened.  exiting.\n",argv[1]);
    return 0;
  }

  res1 = ioctl(fd, CDROM_MEDIA_CHANGED, &arg);
  res2 = ioctl(fd, CDROM_DRIVE_STATUS, &arg);

  if (res1 == 0 && res2 == CDS_DISC_OK ) { 
      printf ("FOUND CD!\n");
  } 

  cdtype = ioctl (fd, CDROM_DISC_STATUS, CDSL_CURRENT);
  switch (cdtype) {
  case CDS_AUDIO:
	printf("AUDIO CD\n");
	break;

  case CDS_MIXED:
	printf("MIXED CD\n");
	break;

  case CDS_DATA_1:
	printf("DATA1 CD\n");
  	break;
  case CDS_DATA_2:
	printf("DATA2 CD\n");
  	break;
  case CDS_XA_2_1:
	printf("XA_2_1 CD\n");
  	break;
  case CDS_XA_2_2:
	printf("XA_2_2 CD\n");
  	break;
  case CDS_NO_INFO:
	printf("No info on CD\n");
  	break;
  default:
  	break;

  }
  close(fd);
  return 0;
}
